<?php
/**
 * The template for displaying Archive pages.
 *
 * Used to display archive-type pages if nothing more specific matches a query.
 * For example, puts together date-based pages if no date.php file exists.
 *
 * Learn more: http://codex.wordpress.org/Template_Hierarchy
 *
 */
$empty_error_msg = ''; //if no posts it will be used to pass msg to no-content.php
get_header(); ?>
    <div class="info-bar" id="begin-of-content">
        <div class="inside">
        <?php
	/* Queue the first post, that way we know
	 * what date we're dealing with (if that is the case).
	 *
	 * We reset this later so we can run the loop
	 * properly with a call to rewind_posts().
	 */
	if ( have_posts() )
		the_post();
?>
            <h1 class="page-title">
<?php if ( is_author() ) : ?>
				<?php printf( __fe( 'Author Archives: %s' ), "<span class='vcard'>" . get_the_author() . "</span>" ); ?>
<?php elseif ( is_category() ) : ?>
				<?php printf( __fe( 'Category Archives: %s' ), '<span>' . single_cat_title( '', false ) . '</span>' ); ?>
<?php elseif ( is_tag() ) : ?>
				<?php printf( __fe( 'Tag Archives: %s' ), '<span>' . single_tag_title( '', false ) . '</span>' ); ?>
<?php elseif ( is_day() ) : ?>
				<?php printf( __fe( 'Daily Archives: %s' ), '<span>' . get_the_date() . '</span>' ); ?>
<?php elseif ( is_month() ) : ?>
				<?php printf( __fe( 'Monthly Archives: %s' ), '<span>' . get_the_date( 'F Y' ) . '</span>' ); ?>
<?php elseif ( is_year() ) : ?>
				<?php printf( __fe( 'Yearly Archives: %s' ), '<span>' . get_the_date( 'Y' ) . '</span>' ); ?>
<?php else : ?>
				<?php _fe( 'Blog Archives' ); ?>
<?php endif; ?>
			<?php
			/* Since we called the_post() above, we need to
			 * rewind the loop back to the beginning that way
			 * we can run the loop properly, in full.
			 */
			rewind_posts();
            ?>
            </h1>
        </div>
    </div>
    <div id="content">
        <div class="inside clearfix">
            <article>
                <?php
                /* Run the loop to output the post.
                 * If you want to overload this in a child theme then include a file
                 * called loop-single.php and that will be used instead.
                 */
                get_template_part( 'loop' );
                ?>

                <?php a13_blog_nav(); ?>
            </article>
            <?php get_sidebar(); ?>
        </div>
    </div>
<?php get_footer(); ?>
