//if someone use prototype or other library
//we better be safe :-)
jQuery.noConflict();

(function($, window, document){
    /*global ApolloParams, Modernizr, debounce, throttle, addthis */
    "use strict";

    var A13,
        $html       = $(document.documentElement),
        body        = document.body,
        $body       = $(body),
        $window     = $(window),
        G           = ApolloParams,
        isTouch     = Modernizr.touch,
        header, mid, root,//html elements

        validation  = {
            errorTime : 5000, /* duration of message after error in form */
            submitTime : 10000 /* duration of message after submit form */
        },
        ligthboxSettings =
        {
            //change some animation functions
            anims : {
                showBg : function(nm, clb) {
                    nm.elts.bg.show();
                    clb();
                },
//              same as default
                resize: function(nm, clb) {
                    //update margins for responsive
                    var outer=nm.getInternal()._getOuter(nm.elts.cont);
                    nm.sizes.hMargin=outer.h.total;
                    nm.sizes.wMargin=outer.w.total;

                    nm.elts.cont.css({
                        width: nm.sizes.w,
                        height: nm.sizes.h,
                        top: (nm.getInternal().fullSize.viewH - nm.sizes.h - nm.sizes.hMargin)/2,
                        left: (nm.getInternal().fullSize.viewW - nm.sizes.w - nm.sizes.wMargin)/2
                    });
                    clb();
                }
            },
            //makes resize of title area also
            _reposition: function() {
                var elts = this.elts.cont.find('.nmReposition');
                if (elts.length) {
                    var space = this.getInternal()._getSpaceReposition();
                    elts.each(function() {
                        var me = $(this),
                            offset = me.offset();
                        me.css({
                            position: 'fixed',
                            top: offset.top - space.top,
                            left: offset.left - space.left
                        });
                    });
                    this.elts.cont.after(elts);
                }

                //set width for title
                if(this.store.title){
                    this.store.title.width(this.sizes.w);
                }

                this._callFilters('afterReposition');
            }
        },

        addLoader = function(){
            if($('#loader').length){ return; }//there is some loader
            var _appendTo = isTouch? mid : $body;
            $('<div id="loader" />').appendTo(_appendTo).hide().fadeIn();
        },
        removeLoader = function(){
            var l = $body.find('#loader');
            l.fadeOut().promise().done(function(){l.remove();});
        };


    window.A13 = { //A13 = APOLLO 13
        //run after DOM is loaded
        onReady : function(){
            if(typeof $.fn.masonry !== 'undefined'){
                //add scroll bar to fix some delayed resize issues
                $html.addClass('show-scroll');
            }

            //bind html elements to vars
            mid = $('#mid');
            header = $('#header');
            root = $('#root');

//            log ($window.width(), $window.height());

            //bind resize
            $window.resize(debounce(A13.layout.resize, 250));
            A13.layout.set(); //set current size
            A13.runPlugins();
            A13.elementsActions.init();
            A13.albumsListActions.init();
            A13.albumViewActions.init();
        },

        layout : {
            pointers : [],

            size : 0,

            add : function(f){
                A13.layout.pointers.push(f);
            },

            set : function(){
                var size = getComputedStyle(body,':after').getPropertyValue('content'),
                    width = $window.width(),
                    index = (size === null)? -1 : size.indexOf("narrow"),
                    to_return;

                //if we can get value of current media query(normal desktop broswers)
                if(index !== -1){
                    to_return = parseInt(size.substr(index + 6), 10);
                }
                //most mobile browsers can't get above so we get normal window measure
                else{
                    to_return = width;
                }

                A13.layout.size = to_return;

                return to_return;
            },

            resize : function(e){
                //log ('go go resize callbacks!')
                var A = A13.layout,
                    size = A.set(),
                    pointers = A.pointers;

//                log ('window size: '+$window.width()+' X '+$window.height());
//                log ('resize ', e.timeStamp);

                //call each registered for resize function
                for(var i = 0; i < pointers.length; i++){
                    pointers[i].call(this, e, size);
                }
            }
        },

        runPlugins : function(){
            //HTML5 Placeholders
            var ph = $('input[placeholder], textarea[placeholder]');
            if (ph.length) {
                ph.placeholder();
            }

            //change filters for lightbox
            if(typeof $.fn.nm !== 'undefined'){
                $.nmFilters({
                    gallery: {
                        beforeShowCont : function(nm) {
                            if (nm.galleryCounts && nm.store.title && nm.store.galleryLinks && nm.store.galleryLinks.length > 1) {
                                var is_album = $body.hasClass('single-album'),
                                    images = G.album_images,
                                    total = nm.store.galleryLinks.length;

                                //bricks theme so we need to know how many photos is there cause lazy load wont show all from start
                                if(is_album && G.album_theme === 'bricks' && images.length){
                                    total = images.length;
                                }

                                nm.store.title.append('<div class="nyroModalCount">'+(nm.store.galleryIndex+1)+' / '+total+'</div>');
                            }
                        }
                    },
                    title: {
                        beforeShowCont: function(nm) {
                            //we check for stored elements in DOM
                            //cause we can't store HTML in title attribute
                            var id = nm.opener.data('id'),
                                attr_title = nm.opener.attr('title'),
                                title;

                            if(typeof id !== 'undefined'){
                                title = $('#brick-title-'+id).html();
                            }
                            else{
                                title = attr_title;
                            }

                            nm.store.title = $('<div class="nyroModalTexts nmReposition" />').append($('<h1 />', {
                                html: title
                            }).addClass('nyroModalTitle')).width(nm.sizes.w);
                            nm.elts.cont.append(nm.store.title);
                        }
                    },
                    custom : {
                        initElts : function(/*nm*/){
                            //bricks theme so we need to scroll to bottom to activate lazy load to load other photos
                            if($body.hasClass('single-album')){
                                $window
//                                    .scrollTop($('#bricks-album').height())
                                    .trigger('scroll.lazyload', true);
                            }
                        }
                    }
                });
            }
        },

        elementsActions : {
            init : function(){
                var $e = A13.elementsActions;

                /******* GLASS EFFECT *********/
                $e.glass();

                /******* TOP MENU *********/
                //fired in layoutResize function
                $e.topMenu();

                /******* SOCIAL ICONS *********/
                $e.socials();

                /******* TOP SEARCH FORM *********/
                $e.search();

                /******* TO TOP LINK *********/
                $e.toTop();

                /******* SCROLLING HEADER *********/
                $e.header();

                /******* HEAD WIDGETS *********/
                $e.headWidgets();

                /******* HEADER MUSIC *********/
                $e.headerMusic();

                /******* BLOG FILTER *********/
                $e.blogFilter();

                /******* BLOG MASONRY *********/
                $e.blogMasonry();

                /******* Contact & Comment validation *********/
                $e.formValidation();

                /******* Tabs from short codes *********/
                $e.shortCodeTabs();

                /******* Lightbox *********/
                $e.lightbox();

                /******* FLEXSLIDER *********/
                if(typeof $.flexslider !== 'undefined'){
                    $(window).load(function() {
                        $('div.flexslider').flexslider({
                            slideshow: false
                        });
                    });
                }
            },

            glass : function(){
                var glass = $('.glass'),
                    fs_switch = $('#switch-glass');

                if(glass.length && fs_switch.length){
                    var f_i_t   = 300, //fade in time
                        f_o_t   = 300, //fade out time

                        hov_in = function(elem){
                            //move glass switch
                            $('#fs-replace').replaceWith(fs_switch).remove();
                            fs_switch
                                .text(fs_switch.data('fullscreen'))
                                .removeClass('off');
                                //rebind glass switch
//                                .click(attachClick); //no need for it when you move element

                            elem.stop().css('visibility', 'visible').animate({
                                opacity : 1
                            },f_i_t,'swing');
                        },

                        hov_out = function(elem){
                            elem.stop()
                                .animate({
                                    opacity : 0
                                },f_o_t,'swing')
                                .promise()
                                .done( function(){
                                    elem.css('visibility', 'hidden');

                                    //move glass switch
                                    fs_switch
                                        .replaceWith('<span id="fs-replace" />')
                                        .appendTo(body)
                                        .text(fs_switch.data('normal'))
                                        .addClass('off')
                                        //rebind glass switch
                                        .click(attachClick);
                            });
                        },

                        attachClick = function(){
                            if($(this).hasClass('off')){
                                hov_in(glass);
                            }
                            else{
                                hov_out(glass);
                            }
                        };

                    //bind glass switch
                    fs_switch.click(attachClick);
                }
            },

            glassIconGlow : function(){
                var s = $('#switch-glass');

                if(s.length && !s.hasClass('off')){
                    s
                        .addClass('glow')
                        .animate({opacity: 0.2}, 300)
                        .animate({opacity: 1}, 300)
                        .animate({opacity: 0.2}, 300,function(){
                            s.removeClass('glow');
                        })
                        .animate({opacity: 1}, 300);
                }
            },

            topMenu : function(){
                var a = $('#access'),
                    sub_menus = a.find('ul.sub-menu'),
                    sub_parents = sub_menus.parent(),
                    logo = $('#logo').children(), //#logo img
                    menu = a.children('div.menu-container'),
                    menu_list = menu.children(),
                    menu_init = a.find('h3.assistive-text'),
                    src, menu_h,
                    size = A13.layout.size,
                    useNormalMenu = !!parseInt(G.touch_classic_menu,10),

                    registerHover = function(){
                        //Hover action
                        sub_parents.hoverIntent({
                            over: function(){
                                var _this = $(this),
                                    sub = _this.children('ul.sub-menu');
                                //better homogeneity
                                _this.addClass('hovered');
                                //hide every menu that is open on same level
                                _this.siblings('li').has('ul').removeClass('hovered')
                                    .children('ul').removeClass('otherway').hide();
                                measureSubmenu(sub);
                                //show sub-menu
                                sub.fadeIn(200);
                            },
                            out: function(){
                                $(this).removeClass('hovered')
                                    .children('ul.sub-menu').fadeOut(150, function(){ $(this).removeClass('otherway'); });
                            },
                            interval: 50,
                            timeout: 500
                        });
                    },

                    unregisterHover = function(){
                        //unbind hoverintent
                        sub_parents
                            .unbind("mouseenter")
                            .unbind("mouseleave")
                            .removeProp('hoverIntent_t')
                            .removeProp('hoverIntent_s');
                    },

                    mobile_menu_toggle = function(){
                        if(menu.hasClass('open')){
                            menu.slideUp(200, function(){
                                menu_list.hide();//helps with menu 'flicker' on IOS
                            });
                            menu.removeClass('open');
                        }
                        else{
                            menu_list.show(); //helps with menu 'flicker' on IOS
                            menu.slideDown(200);
                            menu.addClass('open');
                        }
                    },

                    mobile_submenu_toggle = function(e){
                        var menu = $(this).children('ul');

                        if(!menu.hasClass('open')){
                            menu.slideDown(200);
                            menu.addClass('open');
                            e.preventDefault();
                        }
                    },

                    logoSizeMenu = function(){
                        menu_h = logo.parent().innerHeight();
                        a.find('div.menu-container').children().css('height', menu_h)
                            //ul > li > a
                            .children().children()
                            .css('line-height', menu_h+'px');
                    },

                    normalSizeMenu = function(){
                        a.find('div.menu-container').children().css('height', '')
                            //ul > li > a
                            .children().children()
                            .css('line-height', '');
                    },

                    measureSubmenu = function(sub){
                        //values
                        var width = $window.width(),
                            sub_w = sub.css({
                                visibility: 'hidden',
                                display: 'block'
                            }).width(),
                            offset = sub.offset();

                        //set back
                        sub.css({
                            visibility: 'visible',
                            display: 'none'
                        });

                        //out of right edge of screen, then show on other side
                        if(offset.left + sub_w > width ){
                            sub.addClass('otherway');
                        }
                    },
                    //resize for menu
                    layout = function(event, size){
                        //if wide screen and not touch Screen, or forced to use normal menu
                        if(size > 650  && (!isTouch || useNormalMenu)){
                            a.removeClass('touch clearfix');
                            menu_init.off('.touch');
                            //clean after touch menu
                            menu.removeClass('open').attr('style','');

                            if(sub_menus.length){
                                sub_parents.off('.touch');
                                //clean after touch menu
                                sub_menus.removeClass('open').hide();
                                registerHover();
                            }
                        }
                        else{
                            a.addClass('touch clearfix');
                            //bind open menu
                            //no double binds!
                            menu_init.off('.touch');
                            menu_init.on('click.touch', mobile_menu_toggle);

                            if(sub_menus.length){
                                unregisterHover();
                                //bind open submenu
                                //no double binds!
                                sub_parents.off('.touch');
                                sub_parents.on('click.touch', mobile_submenu_toggle);
                            }
                        }
                    };

                if(sub_menus.length){
                    //add class for last menu option cause.
                    //It is for its descendant drop down menu to not go out of the scope
                    a.find('ul.top-menu').children().filter(":last").addClass('last');

                    sub_parents.addClass('parent');
                }

                //register resize
                A13.layout.add(layout);

                //initial layout
                layout({}, size);

                //show menu
                menu.addClass('loaded');

                //resize menu to logo size
                if(logo.length){
                    src = logo.attr('src');

                    //init resize
                    if(size > 650){
                        logo
                            .load(function(){
                                if(!isTouch || useNormalMenu){
                                    logoSizeMenu();
                                }

                                //inform about possible resize
                                $body.trigger('logoLoaded');
                            })
                            //reset src, and set again to fire load event
                            .attr('src', '').attr('src', src);
                    }

                    //register resize
                    A13.layout.add(function(e, size){
                        if(size > 650 && (!isTouch || useNormalMenu)){
                            logoSizeMenu();
                        }
                        else{
                            normalSizeMenu();
                        }
                    });
                }
            },

            search :  function(){
                var sf = header.find('form.search-form');
                if(sf.length){
                    sf.prev()//span.action
                        .click(function(){
                        if(sf.is(':visible')){
                            sf.fadeOut(200);
                        }
                        else{
                            sf.fadeIn(200, function(){
                                sf.find('input[name="s"]').focus();
                            });
                        }
                    });
                }
            },

            toTop : function(){
                var tt = $('#to-top'),
                    cb = function(){
                        if ($window.scrollTop() > 100) {
                            tt.show();
                        } else {
                            tt.hide();
                        }
                    };

                if(tt.length){
                    cb(); //fire after refresh
                    $window.scroll(debounce(cb, 250));

                    // scroll body to 0px on click
                    tt.click(function () {
                        $('body,html').animate({
                            scrollTop: 0
                        }, 800);
                        return false;
                    });
                }
            },

            header:  function(){
                var header = $('#header-container');

                if(header.hasClass('sticky')){
                    var header_size = header.height(),
                        _class = 'fixed',
                        logo = $('#logo').children(),

                    //resize function
                        cb = function(){
                            if($window.scrollTop() > header_size && !header.hasClass(_class)){
                                header.addClass(_class);
                                root.css('padding-top', header_size);
                            }
                            else if($window.scrollTop() < header_size && header.hasClass(_class)){
                                header.removeClass(_class);
                                root.css('padding-top', '');
                            }
                        };

                    //if img logo we need event for loading it
                    if(logo.is('img')){
                        logo.load(function(){
                            //inform about possible resize
                            header_size = header.height();
                            $body.trigger('logoLoaded');
                        });
                    }

                    //measure again after logo is loaded
                    $body.on('logoLoaded', cb);

                    $window.scroll(throttle(cb, 250));
                }
            },

            socials : function(){
                var socials = header.find('div.visible');

                if(socials.length){
                    var
                        slide           = socials.children(),
                        icons           = slide.children(), //.slide > a
                        icons_number    = icons.length,
                        icon_height     = icons.eq(0).outerHeight(true),//+ margin included
                        icon_width      = parseInt(G.social_icon_width, 10),//+ margin included
                        visible_icons   = parseInt(G.social_number_of_visible, 10),
                        rows            = Math.ceil(icons_number/visible_icons),
                        slide_height    = rows * icon_height,
                        slide_width     = visible_icons * icon_width;

                    //if more space then icons
                    if(visible_icons > icons_number){
                        slide_width = icons_number * icon_width;
                    }

                    var mouseOver = function(){
                            socials.addClass('hover');
                            slide.stop().animate({
                                height : slide_height
                            }, 300, 'swing');
                        },
                        mouseOut = function(){
                            slide.stop().animate({
                                height : icon_height
                            }, 300, 'swing',function(){
                                socials.removeClass('hover');
                            });
                        },
                        //resize for socials
                        layout = function(event, size){
                            if(size > 650 && !isTouch){
                                socials
                                    .show()
                                    //no double BINDS!
                                    .off('.social')
                                    .on('mouseover.social', mouseOver)
                                    .on('mouseout.social', mouseOut);

                                //set calculated dimensions
                                slide.css({
                                    height : icon_height,
                                    width  : slide_width
                                });
                            }
                            else{
                                socials
                                    .show()
                                    .off('.social');

                                //reset dimensions
                                slide.css({
                                    height : '',
                                    width  : ''
                                });
                            }
                        },
                        size = A13.layout.size;

                    A13.layout.add(layout);

                    //initial layout
                    layout({}, size);
                }
            },

            headerMusic : function(){
                // if player is turned on
                if(G.header_music_player === 'on'){
                    var mp3 = $.trim(G.header_music_mp3),
                        oga = $.trim(G.header_music_ogg),
                        autoplay = ($.trim(G.header_music_autoplay) === 'on'),
                        params = {}, supplied = '';

                    //if no files then hide and exit
                    if(mp3.length === 0 && oga.length === 0){
                        $('#jpHeaderPlayer').hide();
                        return;
                    }

                    if(mp3.length){
                        params.mp3 = mp3;
                        supplied += 'mp3,';
                    }
                    if(oga.length){
                        params.oga = oga;
                        supplied += 'oga';
                    }

                    $("#jpAudioContainer").jPlayer({
                        ready: function () {
                            var t = $(this);

                            t.jPlayer("setMedia", params);
                            if(autoplay){
                                t.jPlayer("play");
                            }
                        },
                        cssSelectorAncestor: "#jpHeaderPlayer",
                        loop : true,
                        swfPath: G.js_dir + '/audio/',
                        supplied: supplied,
                        wmode: "window"
                    });
                }
            },

            headWidgets : function(){
                var hw = $('#head-widgets');

                if(hw.length){
                    //show/hide header widgets area
                    var handle = hw.find('span.handle'),
                        addons = header.find('div.add-ons').children();
                    //if not there search for it in header
                    if(!handle.length){
                        addons.find('span.handle');
                    }

                    var textH = handle.children().eq(0),
                        content = hw.children('div.content'),
                        layout = function(event, size){
                            if(size > 650){
                                hw.append(handle);
                            }
                            else{
                                addons.append(handle);
                            }
                        },
                        size = A13.layout.size;

                    A13.layout.add(layout);

                    //initial layout
                    layout({}, size);

                    //set text for handle
                    if(hw.is('.open')){ textH.text(handle.data('hide')); }
                    else{
                        textH.text(handle.data('show'));
                    }

                    handle.click(function(){
                        if(hw.is('.open')){
                            content.slideUp();
                            textH.text(handle.data('show'));
                            hw.removeClass('open');
                        }
                        else{
                            //empty start inline style
                            content.attr('style','').hide();
                            content.slideDown();
                            textH.text(handle.data('hide'));
                            hw.addClass('open');
                        }
                    });
                }
            },

            blogFilter : function(){
                var bf = $('#filter-activate');
                if(bf.length){
                    var f = bf.next(); //div with filters
                    bf.click(function(){
                        if(f.is(':visible')){
                            bf.removeClass('active');
                            f.slideUp();
                        }
                        else{
                            bf.addClass('active');
                            f.slideDown();
                        }
                    });
                }
            },

            blogMasonry : function(){
                var $container = $('#masonry-parent');
                if($container.length){
                    var layout = function(event, size){
                            if(size > 650 && !$container.hasClass('masonry')){
                                addLoader();

                                $container.imagesLoaded(
                                    function(){
                                        $container.masonry({
                                            itemSelector : 'div.brick',
                                            columnWidth : parseInt(G.brick_width, 10) + parseInt(G.brick_margin, 10),
                                            isFitWidth : !!parseInt(G.masonry_full_width, 10),
                                            isAnimated: !Modernizr.csstransitions,
                                            animationOptions: {
                                                duration: 300,
                                                easing: 'swing',
                                                queue: false
                                            }
                                        });

                                        //remove loading and fade item
                                        $container
                                            .css({
                                                opacity : 0
                                            })
                                            .addClass('loaded')
                                            .animate({opacity: 1}, 700);

                                        removeLoader();
                                    });

                                //turn off throttle for window resize
                                $.resize.throttleWindow = false;

                                //resize of brick elements
                                $container.find('div.brick').on('resize', function(){
                                    //reposition elements
                                    $container.masonry();
                                });
                            }
                            else if(size <= 650 && $container.hasClass('masonry')){
                                $container.masonry('destroy');
                                $container.find('div.brick').off('resize');
                            }
                        },
                        size = A13.layout.size;

                    A13.layout.add(layout);

                    //initial layout
                    layout({}, size);

                }
            },

            formValidation : function(){
                //if enabled theme validation, then validate also comment form
                var c_f_selector, c_f;
                if($body.hasClass(G.validation_class)){
                    c_f_selector = '#commentform, form[name="apollo-contact-form"]';
                }
                else{
                    c_f_selector = 'form[name="apollo-contact-form"]';
                }

                c_f = $(c_f_selector);
                if (c_f.length) {
                    (function(){
                        var times = validation,
                            error_i = c_f.find('div.error-info').css('opacity', 0),
                            submit_i = c_f.find('div.submit-info').delay(times.submitTime).slideUp(),
                            comment_submit = $('#comment-submit');

                        //fix for not submitting form after check http://jibbering.com/faq/names/
                        if(comment_submit.length){
                            comment_submit.attr('name','othername');
                        }

                        c_f.submit(function(e){
                            var form = $(this),
                                error_number = 0,
                                inputs = form.find('input[aria-required], textarea'), //only required fields
                                captcha = form.find('input[name="cptch_number"]');

                            //check if captcha is used
                            if(captcha.length){ inputs = inputs.add(captcha); }

                            //check every input for errors
                            for(var item = 0; item < inputs.length; item++){
                                var inp = inputs.eq(item),
                                    inp_p = inp.parent();
                                //scan for empty fields
                                if( ! $.trim( inp.val()).length ){
                                    inp_p.addClass('error');
                                    error_number++;
                                    continue;
                                }

                                //check e-mail field
                                if( inp.is('#email') ){
                                    var emailRegEx = /^[A-Z0-9._%+\-]+@[A-Z0-9.\-]+\.[A-Z]{2,4}$/i;
                                    if (inp.val().search(emailRegEx) === -1) {
                                        inp_p.addClass('error');
                                        error_number++;
                                        continue;
                                    }
                                }

                                // everything ok
                                inp.parent().removeClass('error');
                            }

                            //if there were some errors
                            if( error_number > 0 ){
                                e.preventDefault();
                                //animate error text
                                if(submit_i.length){
                                    //hide submit message
                                    submit_i.stop().slideUp();
                                }
                                error_i.stop().css('opacity', 1)
                                    .animate({
                                        opacity : 0
                                    }, times.errorTime);
                            }
                            //no errors - normal submit
                        });
                    })(); // <---- call it instantly
                }
            },

            shortCodeTabs : function(){
                //tabs Container
                var tC = $('div.tabsCell');

                if(tC.length){
                    var tabs = tC.find('div.tab_content').hide(),
                        tabsOptions = tC.find('ul.tabs li'); //Hide all content

                    //Default Action
                    tabsOptions.filter(':first-child').addClass('active'); //Activate first tab
                    tabs.filter(':first-child').show(); //Show first tab content

                    //On Click Event
                    tabsOptions.click(function(e) {
                        e.preventDefault();

                        var tab = $(this),
                            parent = tab.parents('div.tabsCell').eq(0),
                            activeTab = tab.find("a").attr("href"); //Find the rel attribute value to identify the active tab + content

                        if(tab.hasClass('active')){
                            return;
                        }

                        tab.siblings().removeClass('active'); //Remove any "active" class
                        tab.addClass('active'); //Add "active" class to selected tab
                        parent.find('div.tab_content').hide(); //Hide all tab content
                        parent.find(activeTab).fadeIn(); //Fade in the active content
                    });
                }
            },

            lightbox : function(){
                if(typeof $.fn.nm !== 'undefined'){
                    $('a.alpha-scope').nm(ligthboxSettings);
                }
            }
        },

        albumsListActions : {
            init : function(){
                var t = A13.albumsListActions,
                    slider = $('#albums-view-slider'),
                    bricks = $('#albums-view-bricks');

                if(slider.length){
                    t.slider(slider);
                }
                else if(bricks.length){
                    t.bricks(bricks);
                }
            },

            slider : function(gallery){
                var albums          = gallery.children(),
                    images          = albums.find('img'),//redefined in every function cause of reloads
                    visible         = $('#content'),
                    prev            = mid.children('.arrow-left'),
                    next            = mid.children('.arrow-right'),
                    cover           = '<em class="cover"></em>',

                    visibleWidth    = visible.width(),
                    m_h             = mid.height(),
                    albums_count    = albums.length,
                    images_count    = images.length,
                    total_width     = 0,
                    animationTime   = parseInt(G.albums_animationTime, 10),
                    loadingFadeTime = parseInt(G.albums_loadingFadeTime, 10),
                    borderWidth     = parseInt(G.albums_borderWidth, 10),
                    activeZoom      = parseInt(G.albums_activeZoom, 10),/*px*/
                    spaceOutside    = parseInt(G.albums_spaceOutside, 10),/*px*/
                    maxHeight       = parseInt(G.albums_maxHeight, 10),
                    startItem       = G.albums_startItem,
                    animated        = false,
                    imagesShown     = false,
                    g_inner_space   = spaceOutside + activeZoom + borderWidth,
                    g_h,

                    defaultSizes = function(){
                        var f = $('#footer');

                        //reset
                        mid.css('height','');

                        var h_h = header.outerHeight(), //widget area doesn't matter
                            f_h = f.height(),
                            r_h = root.height(),
                            m_h = r_h - f_h - h_h;
//log (h_h,f_h,r_h,m_h)
                        if(g_inner_space > 0 && m_h < g_inner_space*3 ){
                            m_h = g_inner_space*3; //min height = 3 * active item bonus space
                        }

                        mid.css('height', m_h);

                        //height of gallery
                        if( m_h >= maxHeight + g_inner_space*2){
                            g_h = maxHeight;
                        }
                        else{
                            g_h = m_h - g_inner_space*2;
                        }

                        //set it
                        gallery.css({
                            height         : g_h,
                            //make place for 'scroll centering'
                            'padding-left' : 1000,
                            'padding-right': 1000
                        });

                        visible.css({
                            marginTop     : -(g_h + g_inner_space*2)/2,
                            //place for zooming
                            paddingTop    : g_inner_space,
                            paddingBottom : g_inner_space
                        });
                    },

                    gallery_init = function(){
                        var imagesToFade = '',
                            start_item,
                            //resize for albums
                            layout = function(e, size){
                                if(size > 650  && !isTouch){
                                    //scrolling bind
                                    visible.unmousewheel(mouseScroll);
                                    visible.mousewheel(mouseScroll);
                                }
                                else{
                                    //scrolling disable
                                    visible.unmousewheel(mouseScroll);
                                }
                                redrawGallery();
                            },
                            size = A13.layout.size;

                        defaultSizes();

                        /* CALL IT ALL */

                        //fill albums with counter
                        for(var item = 0; item < albums_count; item++ ){
                            $.data(albums[item], 'uid', item);
                        }

                        //arrows clicking bind
                        prev.add(next).click(arrowNavClick);

                        //album click
                        albums.click(clickItem);

                        A13.layout.add(layout);
                        $body.on('logoLoaded', redrawGallery);

                        //init size layout
                        if(size > 650  && !isTouch){
                            //scrolling bind
                            visible.mousewheel(mouseScroll);
                        }
                        else{
                            //scrolling disable
                            visible.unmousewheel(mouseScroll);
                        }

                        //hide all images and show spinners
                        addLoader();
                        images.parent().hide();

                        //set total width for loading images

                        if(startItem === ''){
                            start_item = 0;
                        }
                        else{
                            start_item = albums.index(document.getElementById('album-' + startItem));
                        }
//                log (start_item, $s.startItem, '#album-' + $s.startItem, $s.albums);

                        //counter to know which item is displayed
                        visible.data('counter',start_item);

                        var load_img = function(index, src){
                            var $curr_img = images.eq(index),
                                curr_img = $curr_img[0],
                                $new_img = $('<img />'),
                                gallery_h = gallery.height();

                            $new_img
                                // once the image has loaded, execute this code
                                .load(function() {
                                    var $this_img = $(this),
                                        parent_w;

                                    //IE generated image fix
                                    $this_img.removeAttr('width').removeAttr('height');

                                    $this_img.hide();
                                    $curr_img.parent().show()
                                        // remove set width and spinner
                                        .css('width','')
                                        // remove 'default' image
                                        .children('img').remove().end()
                                        // add cover
                                        .prepend(cover)
                                        // then insert our refreshed image
                                        .prepend(this);

                                    //prepare image for measure
                                    $this_img
                                        .css({
                                            height     : gallery_h,
                                            display    : 'block',
                                            visibility : 'hidden'
                                        })
                                        .parent().css('position','absolute');

                                    //fix for floating width and reset css
                                    parent_w = $this_img.parent().width();
                                    $this_img.css('width', parent_w);

                                    //save current dimensions
                                    $.data(this,'width',parent_w);
                                    $.data(this,'height',$this_img.height());

                                    //update total width
                                    updateTotalWidth(parent_w);
                                    //back to normal flow
                                    $this_img.parent().css('position','');

                                    //animate image
                                    //if it is first item scroll to it instantly and activate
                                    if(index === start_item){
                                        removeLoader();
                                        //to reset position on page refresh
                                        scrollGallery(start_item,0);

                                        //show this image and other pending
                                        imagesShown = true;
                                        $this_img.add(imagesToFade)
                                            .css('visibility', '').hide()
                                            .fadeIn(loadingFadeTime)
                                            .promise().done(function(){
                                                activateItem(start_item);
                                                $this_img.add(imagesToFade).parent().addClass('loaded');
                                            });
                                    }
                                    else{
                                        //images were already shown, so show this one
                                        if(imagesShown){
                                            $this_img
                                                .css('visibility', '').hide()
                                                .fadeIn(loadingFadeTime)
                                                .parent().addClass('loaded');
                                        }
                                        else{
                                            //save image for later fadeIn
                                            imagesToFade = $this_img.add(imagesToFade);
                                        }
                                    }

                                    //load next image
                                    if(index + 1 < images_count){
                                        load_img(index + 1);
                                    }
                                })
                                .error(function(/*event*/){
//                                    console.log ('inserting default image for item ' + index);
                                    load_img(index, G.images_dir + G.placeholder_image);
                                });

                            // *finally*, set the src attribute of the new image to our image
                            if(typeof src === 'undefined'){ //normal load
                                $new_img.attr('src', curr_img.src);
                            }
                            else{ //load placeholder on error
                                $new_img.attr('src', src);
                            }
                        };

                        //start chain
                        load_img(0);
                    },

                    redrawGallery = function(){
                        var current = $.data(visible[0],'counter'),
                            this_img, returned_width, covers,
                            new_total_width = 0;

                        //update settings
                        images          = albums.find('img');
                        covers          = images.next('em.cover');
                        m_h             = mid.height();
                        g_inner_space   = spaceOutside + activeZoom + borderWidth;
                        visibleWidth    = visible.width();

                        defaultSizes();

                        //deactivate item for proper measures
                        if(imagesShown){
                            deactivateItem(current, 0);
                        }

                        //reset images size
                        images.css({
                            height   : g_h,
                            width    : ''
                        });

                        //refresh images, and count new_total_width
                        for(var img = 0; img < images_count; img++){
                            this_img = images.eq(img);
                            returned_width = this_img.parent().width(); //get int width
                            $.data(this_img[0], 'width', returned_width);
                            $.data(this_img[0], 'height', g_h);
                            this_img.css('width', returned_width); //set it to fix floating width of img(FireFox)
                            covers.eq(img).css({width : returned_width, height: g_h});
                            new_total_width += returned_width; //count total width
                        }

                        //set total width
                        gallery.width(new_total_width);

                        if(imagesShown){
                            //reactivate item
                            activateItem(current, 0);
                            //scroll to current item
                            scrollGallery(current, 0);
                        }
                    },

                    updateTotalWidth = function(width){
                        total_width += width;
                        gallery.width(total_width);
                    },

                    activateItem = function(item, time){
                        var _time = time,
                            $item = albums.eq(item),
                            $img  = $item.find('img'),
                            _img  = $img[0],//for faster data retrieve
                            w     = $.data(_img,'width'),
                            h     = $.data(_img,'height'),
                            top,left,ratio;

                        if(typeof _time === 'undefined'){
                            _time = animationTime;
                        }

                        //css for container of new img
                        $item.css({
                            width: w,
                            height: h
                        }).addClass('active');

                        //count ratio zoom and other props
                        ratio = (h + activeZoom*2)/h;
                        top = activeZoom + borderWidth;
                        left = borderWidth + (w*ratio - w)/2;

                        //animate new img
                        $img
                            .css({
                                position: 'absolute',
                                top     :  -borderWidth,
                                left    :  -borderWidth,
                                opacity : 1 //make sure it is applied
                            })
                            .stop()
                            .animate({
                                height: h + activeZoom*2,
                                width: w * ratio,
                                top : -top,
                                left : -left
                            }, _time);

                        //adjust album info width
                        $item.find('h2').stop().animate({
                            marginLeft : -(w*ratio - w)/2,
                            width     : w * ratio
                        },_time);

                        //cover
                        $item.find('em.cover')
                            .stop()
                            .animate({
                                height: h + activeZoom*2,
                                width: w * ratio,
                                top : -top + borderWidth,
                                left : -left + borderWidth
                            }, _time);
                    },

                    deactivateItem = function(item, time){
                        var _time = time,
                            $item = albums.eq(item),
                            $img  = $item.find('img'),
                            _img  = $img[0],//for faster data retrieve
                            w     = $.data(_img,'width'),
                            h     = $.data(_img,'height');

                        if(typeof _time === 'undefined'){
                            _time = animationTime;
                        }

                        //hide album info
                        $item.find('h2').attr('style','');

                        $item.removeClass('active');
                        //animate old img
                        $img
                            .css({
                                opacity: '', //remove on start inline style
                                top     :  '+='+borderWidth,
                                left    :  '+='+borderWidth
                            })
                            .next('em.cover').andSelf()
                            .stop()
                            .animate({
                                width: w,
                                height: h,
                                top: 0,
                                left: 0
                            }, _time, function(){
                                //return to static position
                                $img.css('position', '');

                                //css reset for container of old img
                                $item.css({
                                    width: '',
                                    height: ''
                                });
                            });

                    },

                    changeItems = function(current, prev){
                        //don't do anything on edge cases
                        if(prev !== current){
                            activateItem(current);
                            deactivateItem(prev);
                        }
                    },

                    clickItem = function(event){
                        event.preventDefault();
                        var album = $(this),
                            current = parseInt($.data(this,'uid'), 10),
                            prev = parseInt($.data(visible[0],'counter'), 10);

                        if(album.is('.active')){
                            window.location.href = album.find('a').attr('href');
                        }
                        else{
                            visible.data('counter', current);
                            changeItems(current, prev);
                            scrollGallery(current);
                        }
                    },

                    scrollGallery = function(current, time){
                        var _time  = time,
                            $item  = albums.eq(current),
                            _img   = $item.find('img')[0],
                            w      = $.data(_img,'width'),
                            offset;

                        //used on loading images
                        if(w === undefined){
                            w = $item.width();
                        }
                        offset = visibleWidth/2 - w/2;

                        //use default time if not passed as argument
                        if(typeof _time === 'undefined'){
                            _time = animationTime;
                        }

                        //move
                        animated = true;
                        visible.scrollTo(
                            //current element
                            $item,
                            //time
                            _time,
                            {
                                //offset to center image
                                offset: -offset,
                                //callback to tell that animation has finished
                                onAfter: function(){ animated = false; }
                            }
                        );
                    },

                    arrowNavClick = function(event){
                        event.preventDefault();
                        var arrow = $(this),
                            current = parseInt($.data(visible[0],'counter'), 10),
                            prev = current;

                        //stop scrolling if need
                        if(animated){
                            visible.stop();
                        }

                        //add or deduct ?
                        if( arrow.hasClass('arrow-left') ){
                            current--;
                        }
                        else{
                            current++;
                        }

                        //check limits
                        if( current < 0 ){ current = 0; }
                        if( current >= albums_count ){ current = albums_count - 1; }

                        //save current position
                        visible.data('counter', current);

                        //activate & scroll
                        changeItems(current, prev);
                        scrollGallery(current);
                    },

                    mouseScroll = function(event,delta){
                        event.preventDefault();

                        //scroll backward
                        if(delta > 0){
                            prev.click();
                        }
                        //scroll forward
                        else{
                            next.click();
                        }
                    };

                //start
                gallery_init();
            },

            bricks : function(gallery){
                var defWidth    = parseInt(G.albums_brick_width, 10),
                    defMargin   = parseInt(G.albums_brick_margin, 10),
                    defHeight   = parseInt(G.albums_brick_height, 10),
                    //copy all html to var and remove it from DOM
                    bricksSave  = gallery.children().remove(),
                    imgNo       = bricksSave.length,
                    filter      = $('#albums-filter'),

                    countWidth = function(items){
                        var space = $body.width(),
                            bricks = (items instanceof jQuery)? items : gallery.children(),
                            perRow = parseInt(space/defWidth, 10),
                            fluidWidth = Math.floor((space - (perRow+1) * defMargin) / perRow),
                            fluidHeight;

                        if(
                        //normal width don't fit current space
                            (perRow * defWidth + (perRow+1)*defMargin > space) ||
                                //or items will be wider then 1.2 of normal width
                                (fluidWidth > 1.2 * defWidth)
                            ){
                            perRow++;
                            fluidWidth = Math.floor((space - (perRow+1) * defMargin) / perRow);
                        }

                        bricks.css('width', fluidWidth);
                        if(defHeight > 0){
                            fluidHeight = Math.round(fluidWidth/defWidth * defHeight);
                            bricks.find('img').andSelf().css('height', fluidHeight);
                        }

                        return fluidWidth + defMargin;
                    },

                    loadTillViewIsFull = function(){
                        addLoader();

                        var min = 2,
                            p = gallery.data('pointer'),
                            current = (typeof p === 'undefined')? 0 : parseInt(p, 10),
                            improve = (current + min > imgNo)? imgNo - current : min,
                            limit = current + improve,
                            $newElems, _throttle;

                        //create items html
                        $newElems = bricksSave.slice(current,limit);

                        //append items and position them
                        $newElems
                            .appendTo(gallery)
                            .css({ opacity: 0 })
                            .imagesLoaded(function(){
                                //if load of initial elements
                                if(current === 0){
                                    $newElems.addClass('ready'); // for enabling transition

                                    gallery.masonry({
                                        itemSelector : 'div.brick',
                                        columnWidth : countWidth,
                                        isAnimated: !Modernizr.csstransitions,
                                        isFitWidth: true,
                                        animationOptions: {
                                            duration: 300,
                                            easing: 'swing',
                                            queue: false
                                        }
                                    });

                                    //show elements
                                    $newElems.css({
                                        opacity: 1
                                    });

                                    //show parent
                                    gallery.addClass('loaded');
                                }
                                else{
                                    //resize items
                                    countWidth($newElems);
                                    //show
                                    $newElems.css({
                                        opacity: 1, //show elements
                                        top : $window.height() + $window.scrollTop() + 100 // for animation purpose(animate from bottom of screen
                                    });

                                    //READ of TOP property to break chain for chrome so it makes job proper!!!
                                    //probably chrome optimization error
                                    $newElems.css('top');

                                    $newElems.addClass('ready');

                                    //check if new elements match filter
                                    if(filter.length){
                                        var genre = filter.find('li.selected').data('filter');
                                        if(genre !== '__all'){
                                            $newElems.hide().filter('[data-genre-'+genre+']').show();
                                        }
                                    }
                                    //position
                                    gallery.masonry( 'appended', $newElems, false );//false so it wont go in setTimeout
                                }

                                //save pointer
                                current = current+improve;
                                gallery.data('pointer', current);

                                //load next images if there is space available and still some images to load
                                if(gallery.height() < (2*$window.height() - header.height() + $window.scrollTop()) && current < imgNo){
                                    loadTillViewIsFull();
                                }
                                //bind scroll to load more items
                                else{
                                    removeLoader();

                                    //if we loaded all images
                                    if(current === imgNo){ return; }

                                    var load_more = $('<div class="navigation lazy"><a href="#" id="#load-more">'+ G.load_more +'</a></div>').insertAfter(gallery),
                                        action = function(e){
                                            if(typeof e !== 'undefined'){
                                                e.preventDefault();
                                            }
                                            //instant turn off event
                                            load_more.off('click');

                                            $window.off('.lazyload');
                                            load_more.slideUp(100, function(){load_more.remove();});
                                            loadTillViewIsFull();
                                        },

                                        cb = function(){
                                            var scrollPos = $window.scrollTop() + $window.height() - header.height() - mid.innerHeight() + mid.height();

                                            if (gallery.height() -  scrollPos < 250) {
                                                action();
                                            }
                                        };

                                    load_more.click(action);

                                    //on IOS throttle for scroll causes some JavaScript issues
                                    _throttle = isTouch? 'debounce' : 'throttle';
                                    $window.on('scroll.lazyload resize.lazyload', window[_throttle](cb, 150));
                                }
                            });
                    };

                loadTillViewIsFull();

                //filter
                if(filter.length){
                    var label = filter.find('li.label'),
                        filters = filter.find('li').not(label);

                    label.click(function(){
                        filters.toggle(300);
                    });

                    filters.click(function(e){
                        e.preventDefault();

                        filters.removeClass('selected');

                        var f = $(this).addClass('selected'),
                            genre = f.data('filter'),
                            allItems = gallery.children(),
                            currentItems;

                        if(genre === '__all'){ //__all so users will not overwrite this
                            allItems.show();
                        }
                        else{
                            currentItems = gallery.children().filter('[data-genre-'+genre+']').show();
                            allItems.not(currentItems).hide();
                        }


                        gallery.masonry( 'option', { itemSelector : 'div.brick:visible' }).masonry( 'reload' );
                        $window.trigger('scroll.lazyload');
                    });

                }


                //open album when it is clicked
                gallery.on('click', 'div.brick',{}, function(e){
                    var t = $(this);

//                        console.log(t);
                    if(isTouch && !t.hasClass('touched')){
                        e.preventDefault();//if clicked in link
                        t.addClass('touched').siblings().removeClass('touched');
                    }
                    else{
                        window.location.href = $(this).find('a').attr('href');
                    }
                });
            }
        },

        albumViewActions : {
            init : function(){
                var A = A13.albumViewActions,
                    is_album = $body.hasClass('single-album'),
                    is_protected = $body.hasClass('album-protected'),
                    images = G.album_images;

                //single image background
                if(images.length === 1 && typeof images[0].singlebg !== 'undefined'){
                    A.single(images[0]);
                }
                //bricks theme
                else if(!is_protected && is_album && G.album_theme === 'bricks' && images.length){
                    A.bricksTheme(images);
                }
                // normal theme
                else if(!is_protected && (is_album || images.length)){
                    var thumbs              = parseInt(G.album_thumb_links, 10),
                        fit                 = G.album_fit_image,
                        is_fully_visible    = $body.hasClass('album-fully-visible'),
                        wholeBg_id          = '#whole-bg-image',
                        wholeBg             = $(wholeBg_id),
                        params,

                        //resize #mid if fully_visible
                        layout = function(e, size){
                            var r = root.outerHeight(),
                                h = header.outerHeight(),
                                f = $('#footer').outerHeight(),
                                m = r-f- h,

                                move_album_slider = function(to_root){
                                    if(typeof to_root === "undefined"){
                                        to_root = false;
                                    }

                                    //move album slider
                                    if(to_root && wholeBg.parent().is(mid)){
                                        root.prepend(wholeBg);
                                    }
                                    else if(!to_root && !wholeBg.parent().is(mid)){
                                        mid.append(wholeBg);
                                    }
                                };
//                            console.log(r,f,h,m);
                            //wide width and fully visible
                            if(size > 650 && is_fully_visible){
                                move_album_slider();
                                if(m < 150){ m = 150; } //min 150px
                                mid.height(m);
                            }
                            //only wide width
                            else if(size > 650){
                                move_album_slider(1);
                            }
                            //narrow width
                            else{
                                move_album_slider();
                                mid.height(m);
                            }
                        },
                        size = A13.layout.size;

                    if(is_album){
                        //add to resize event queue
                        A13.layout.add(layout);
                        //initial call
                        layout({}, size);
                        //resize even fire when logo loaded
                        $body.on('logoLoaded', function(){ $window.resize(); });
                    }

                    //normal parameters for album
                    params = {

                        // Functionality
                        theme                   :   'full',
                        parent                  :   wholeBg_id,                             //where will be embeded album-view script
                        autoplay				:	parseInt(G.album_autoplay, 10),			// Slideshow starts playing automatically
                        random                  :   parseInt(G.album_random, 10),			// +Randomize slide order (Ignores start slide)
                        slide_interval          :   parseInt(G.album_slide_interval, 10),	// +Length between transitions
                        transition              :   parseInt(G.album_transition, 10),       // +0-None, 1-Fade, 2-Slide Top, 3-Slide Right, 4-Slide Bottom, 5-Slide Left, 6-Carousel Right, 7-Carousel Left
                        transition_speed		:	parseInt(G.album_slide_transition, 10), // +Speed of transition
                        performance				:	parseInt(G.album_image_quality, 10),	// 0-Normal, 1-Hybrid speed/quality, 2-Optimizes image quality, 3-Optimizes transition speed // (Only works for Firefox/IE, not Webkit)

                        // Size & Position
                        fit_always				:	(fit === 'fit_always'? 1 : 0),			// Image will never exceed browser width or height (Ignores min. dimensions)
                        fit_portrait            :   (fit === 'fit_portrait'? 1 : 0),		// Portrait images will not exceed browser height
                        fit_landscape			:   (fit === 'fit_landscape'? 1 : 0),		// Landscape images will not exceed browser width
                        fit_when_needed			:   (fit === 'fit_when_needed'? 1 : 0),		// Best for small images that shouldn't be stretched

                        // Components
                        thumb_links             :   thumbs,                                 // Individual thumb links for each slide
                        other_albums_links      :   parseInt(G.album_other_albums, 10),     // Enables other albums links
                        share_icon              :   parseInt(G.album_icon_share, 10),       // Enables share icon on slider
                        link_icon               :   parseInt(G.album_icon_link, 10),       // Enables link icon on slider
                        desc_icon               :   parseInt(G.album_icon_desc, 10),       // Enables description icon on slider
                        slides                  :   images,                                 // Slideshow Images

                        // Theme Options
                        show_thumbs_on_start    :   G.album_thumbs_on_start   // show thumbnails on load
                    };

                    //remove/change/add some parameters for non-album page
                    if(!is_album){
                        params.theme = 'bg';
                        params.thumb_links = 0;
                        params.slide_links = 0;
                        params.thumbnail_navigation = 0;
                        params.progress_bar = 0;
                        params.mouse_scrub = 0;
                    }

                    //call script
                    $.album_view(params);
                }
            },

            single: function(img){
                var w = $('#whole-bg-image');

                w
                    .css('backgroundImage', 'url('+img.image+')')
                    .addClass(img.fit);

                A13.setRGBA_n_RGB(w[0], 'backgroundColor', img.bg_color);
            },

            bricksTheme : function(images){
                var cover       = '<em class="cov"></em>',
                    $container  = $('<div id="bricks-album" class="bricks-album" />').appendTo(mid),
                    defWidth    = parseInt(G.album_brick_width, 10),
                    defMargin   = parseInt(G.album_brick_margin, 10),
                    defHeight   = parseInt(G.album_brick_height, 10),
                    imgNo       = images.length,
                    social_things = {},

                    countWidth = function(items){
                        var space = $body.width(),
                            bricks = (items instanceof jQuery)? items : $container.children(),
                            perRow = parseInt(space/defWidth, 10),
                            fluidWidth = Math.floor((space - (perRow+1) * defMargin) / perRow),
                            fluidHeight;

                        if(
                            //normal width don't fit current space
                            (perRow * defWidth + (perRow+1)*defMargin > space) ||
                            //or items will be wider then 1.2 of normal width
                            (fluidWidth > 1.2 * defWidth)
                        ){
                            perRow++;
                            fluidWidth = Math.floor((space - (perRow+1) * defMargin) / perRow);
                        }

                        bricks.css('width', fluidWidth);
                        if(defHeight > 0){
                            fluidHeight = Math.round(fluidWidth/defWidth * defHeight);
                            bricks.find('img').andSelf().css('height', fluidHeight);
                        }

                        return fluidWidth + defMargin;
                    },

                    loadTillViewIsFull = function(){
                        addLoader();

                        var min = 2,
                            p = $container.data('pointer'),
                            current = (typeof p === 'undefined')? 0 : parseInt(p, 10),
                            improve = (current + min > imgNo)? imgNo - current : min,
                            limit = current + improve,
                            with_social_icons = typeof addthis !== 'undefined',
                            html = '',
                            slide, $newElems, _throttle, item;

                        //create items html
                        for(item = current; item < limit; item++ ){
                            slide = images[item];

                            html += '<div class="brick">';
                            html += '<a class="'+slide.type+'" rel="album" href="'+slide.image+'"';
                            html += (typeof slide.id === 'undefined'? '' : ' data-id="'+slide.id+'"');
                            html += (with_social_icons ? ' data-social-id="'+item+'"' : '');
                            html += ' target="_blank"><img src="'+slide.thumb+'" />'+cover+'</a>';
                            html += '</div>';

                            //social icons
                            if(with_social_icons){
                                social_things[item] = { url : slide.link, title: slide.title};
                            }
                        }

                        //append items and position them
                        $newElems = $(html);
                        $newElems
                            .appendTo($container)
                            .css({ opacity: 0 })
                            .imagesLoaded(function(){
                                //if load of initial elements
                                if(current === 0){
                                    $newElems.addClass('ready'); // for enabling transition

                                    $container.masonry({
                                        itemSelector : 'div.brick',
                                        columnWidth : countWidth,
                                        isAnimated: !Modernizr.csstransitions,
                                        isFitWidth: true,
                                        animationOptions: {
                                            duration: 300,
                                            easing: 'swing',
                                            queue: false
                                        }
                                    });

                                    $newElems.css({
                                        opacity: 1
                                    });

                                    //show parent
                                    $container.addClass('loaded');

                                    //lightbox
                                    if(typeof $.fn.nm !== 'undefined'){
                                        $container.find('a').nm(ligthboxSettings);
                                    }
                                }
                                else{
                                    //resize items
                                    countWidth($newElems);
                                    //show
                                    $newElems.css({
                                        opacity: 1, //show elements
                                        top : $window.height() + $window.scrollTop() + 100 // for animation purpose(animate from bottom of screen
                                    });

                                    //READ of TOP property to break chain for chrome so it makes job proper!!!
                                    //probably chrome optimization error
                                    $newElems.css('top');

                                    $newElems.addClass('ready');
                                    //position
                                    $container.masonry( 'appended', $newElems, false );//false so it wont go in setTimeout

                                    //lightbox
                                    if(typeof $.fn.nm !== 'undefined'){
                                        $newElems.find('a').nm(ligthboxSettings);
                                    }
                                }


                                //social icons add
                                if(with_social_icons){
                                    var links = $newElems.find('[data-social-id]'),
                                        curr_id, tempEl, brick_social;

                                    for(item = 0; item < links.length; item++ ){
                                        tempEl = links.eq(item);
                                        curr_id = parseInt(tempEl.attr('data-social-id'), 10);
                                        brick_social =
                                            $('<div class="brick-social">')
                                                .append(''+
                                                '<a class="addthis_button_preferred_1"></a>' +
                                                '<a class="addthis_button_preferred_2"></a>' +
                                                '<a class="addthis_button_preferred_3"></a>' +
                                                '<a class="addthis_button_preferred_4"></a>' +
                                                '<a class="addthis_button_preferred_5"></a>' +
                                                '<a class="addthis_button_compact"></a>'
                                            ).appendTo(tempEl);

                                        //add refreshed social icons
                                        addthis.toolbox(brick_social[0], undefined, {url: social_things[curr_id].url, title: social_things[curr_id].title});
                                    }
                                }

                                //save pointer
                                current = current+improve;
                                $container.data('pointer', current);

                                //load next images if there is space available and still some images to load(preload images for 2*available space)
                                if($container.height() < (2*$window.height() - header.height() + $window.scrollTop()) && current < imgNo){
                                    loadTillViewIsFull();
                                }
                                //bind scroll to load more items
                                else{
                                    removeLoader();

                                    //if we loaded all images
                                    if(current === imgNo){ return; }

                                    var load_more = $('<div class="navigation lazy"><a href="#" id="#load-more">'+ G.load_more +'</a></div>').insertAfter($container),
                                        action = function(e){
                                            if(typeof e !== 'undefined'){
                                                e.preventDefault();
                                            }
                                            //instant turn off event
                                            load_more.off('click');

                                            $window.off('.lazyload');
                                            load_more.slideUp(100, function(){load_more.remove();});
                                            loadTillViewIsFull();
                                        },

                                        cb = function(e, manual){
                                            var scrollPos = $window.scrollTop() + $window.height() - header.height() - mid.innerHeight() + mid.height();

                                            if(typeof manual !== 'undefined' && manual === true){
                                                action();
                                            }
                                            else if ($container.height() -  scrollPos < 250) {
                                                action();
                                            }
                                        };

                                    load_more.click(action);

                                    //on IOS throttle for scroll causes some JavaScript issues
                                    _throttle = isTouch? 'debounce' : 'throttle';
                                    $window.on('scroll.lazyload resize.lazyload', window[_throttle](cb, 150));
                                }
                            });
                    };

                loadTillViewIsFull();
            }
        },

        setRGBA_n_RGB : function(el, style, color){
            if(typeof color === 'undefined' || !color.length){ return; }

            //rgba coversion to rgb
            var reg = /\(\s*(\d+),\s*(\d+),\s*(\d+),\s*(\d+\.?\d*)\s*\)/,
                result = reg.exec(color),
                rgb = '';
            if(result !== null){
                rgb = 'rgb('+result[1]+','+result[2]+','+result[3]+')';
            }

            //set color
            try {
                el.style[style] = color;
            }
            //browsers without RGBA support
            catch(e) {
                el.style[style] = rgb;
            }
        }
    };

    //start Theme
    A13 = window.A13;
    $(document).ready(A13.onReady);

})(jQuery, window, document);