<?php
/**
 * Used in 404 page, sitemap and no search results page
 */
    global $empty_error_msg;
?>
<div class="real-content">
<?php if( is_404() ) : ?>
    <h2 class="title-404"><?php _fe( 'Error 404. The page you\'re looking for can\'t be found' ); ?></h2>
    <span class="info-404"><a href="javascript:history.go(-1)"><?php _fe( 'Go back' ); ?></a> <?php _fe( 'or use Site Map below:' ); ?></span>

<?php elseif(isset($empty_error_msg) && strlen($empty_error_msg)): ?>
    <h2 class="title-404"><?php echo $empty_error_msg; ?></h2>
    <span class="info-404"><a href="javascript:history.go(-1)"><?php _fe( 'Go back' ); ?></a> <?php _fe( 'or use Site Map below:' ); ?></span>

<?php else:
    //site map page content
    if ( have_posts() ){
        while ( have_posts() ){
            the_post();
            the_content();
        }
    }
endif;
    ?>
    <ul>
        <?php
        if ( has_nav_menu( 'header-menu' ) ){
            echo '<li>' . __fe('Main navigation');
            wp_nav_menu( array(
                    'container'       => false,
                    'link_before'     => '',
                    'link_after'      => '',
                    'menu_class'      => '',
                    'theme_location'  => 'header-menu' )
            );
            echo '</li>';
        }

        wp_list_pages();
        wp_list_categories();


        /* List albums */
        global $wp_query, $apollo13;

        $original_query = $wp_query;

        $args = array(
            'posts_per_page'      => -1,
            'offset'              => -1,
            'post_type'           => CUSTOM_POST_TYPE,
            'post_status'         => 'publish',
            'ignore_sticky_posts' => true,
            'meta_key' => '_background_only',
            'meta_value' => '0'
        );

        //make query for albums
        $wp_query = new WP_Query( $args );

        if ($wp_query->have_posts()) :
            echo '<li>' . __fe('Albums');
            echo '<ul>';

            while ( have_posts() ) :
                the_post();
                echo '<li><a href="'. esc_url(get_permalink()) . '">' . get_the_title() . '</a></li>';
            endwhile;

            echo '</ul>';
            echo '</li>';
        endif;

        //restore previous query
        $wp_query = $original_query;
        wp_reset_postdata();
        ?>
    </ul>
</div>