<?php
/**
 * The Template for displaying all single posts.
 *
 */

global $apollo13;
get_header(); ?>
    <?php if ( have_posts() ) : the_post(); ?>

    <?php a13_blog_info_bar(); ?>
    <?php /* Moved id only here cause info-bar can be switched off here */ ?>
    <div id="content">
        <div id="begin-of-content" class="inside clearfix">
            <article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
                <?php
                    if(get_post_meta(get_the_ID(), '_widget_area', true) == 'off')
                        a13_top_image_video( get_the_ID(), 940, 0, 'full' );
                    else
                        a13_top_image_video( get_the_ID(), 600 );
                ?>
                <div class="date_n_author"><?php echo a13_date_and_author(); ?><span class="post-icon"></span></div>

                <h1 class="post-title"><?php the_title() ?></h1>

                <div class="real-content">
                    <?php the_content(); ?>
                    <div class="clear"></div>
                </div>

                <?php
                wp_link_pages( array(
                    'before' => '<div id="page-links">'.__fe('Pages: '),
                    'after'  => '</div>')
                );
                ?>

                <?php a13_post_info(); ?>

                <?php if($apollo13->get_option( 'blog', 'author_info' ) == 'on'): ?>
                <div class="about-author clearfix">
                    <?php echo get_avatar( get_the_author_meta( 'ID' ), 50 ); ?>
                    <div class="author-inside">
                        <strong class="author-name"><?php the_author(); ?>
                            <?php
                            $u_url = get_the_author_meta( 'user_url' );
                            if( ! empty( $u_url ) ){
                                echo '<a href="' . $u_url . '">(' . $u_url . ')</a>';
                            }
                        ?></strong>
                        <div class="author-description">
                            <?php the_author_meta( 'description' ); ?>
                        </div>
                    </div>
                </div>
                <?php endif; ?>

                <?php comments_template( '', true ); ?>
            </article>

            <?php get_sidebar(); ?>
	    </div>
	</div>

    <?php
    else:
        // empty but could redirect to 404, but firstly I have to find condition when this part of code will run
    endif;
    ?>

<?php get_footer(); ?>